VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPropertyDescription"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 09/2018

' enthlt nur die bentigten Funktionen

Option Explicit

Private Const ERR_BASE As Long = 40670
Private Const CLSID_PropertyDescription As String = ""
Private Const IID_IPropertyDescription As String = "{6F79D558-3E96-4549-A1D1-7D75D2288814}"

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetPropertyKey
    vtb_GetCanonicalName
    vtb_GetPropertyType
    vtb_GetDisplayName
    vtb_GetEditInvitation
    vtb_GetTypeFlags
    vtb_GetViewFlags
    vtb_GetDefaultColumnWidth
    vtb_GetDisplayType
    vtb_GetColumnState
    vtb_GetGroupingRange
    vtb_GetRelativeDescriptionType
    vtb_GetRelativeDescription
    vtb_GetSortDescription
    vtb_GetSortDescriptionLabel
    vtb_GetAggregationType
    vtb_GetConditionType
    vtb_GetEnumTypeList
    vtb_CoerceToCanonicalValue
    vtb_FormatForDisplay
    vtb_IsValueCanonical
End Enum

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Public Function GetPropertyType() As VARENUM
    
    Dim eRet As VARENUM
    Dim pvartype As Long
    Dim ppvartype As Long
    
    ppvartype = VarPtr(pvartype)
    
    If x_OleInvoke(vtb_GetPropertyType, ppvartype) Then
        eRet = pvartype
    End If

    GetPropertyType = eRet
    
End Function

Public Function GetDisplayName() As String

    Dim sRet As String
    Dim pszName As Long
    Dim ppszName As Long

    ppszName = VarPtr(pszName)

    If x_OleInvoke(vtb_GetDisplayName, ppszName) Then

        sRet = Ptr2Str(pszName)
        
'        Call CoTaskMemFree(pszName)             '      Roger

    End If

    GetDisplayName = sRet

End Function

Public Sub RaiseError(Optional ByVal Raise As Boolean = True)

    m_Interface.RaiseErrors = Raise

End Sub

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True
    m_Interface.ifc = pInterface
    m_initialized = True

End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Public Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & ".clsIPropertyDescription", .etx

        .ecd = 0
        .etx = vbNullString

    End With

End Sub
